<?php
/*
* 2007-2010 PrestaShop 
*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author UHUPAGE <uhupage@hotmail.com>
*  @copyright  2007-2010 uhupage
*  @version  Release: $Revision: 1.4 $
*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*  International Registered Trademark & Property of uhupage
*/

if (!defined('_CAN_LOAD_FILES_'))
	exit;

class UhuFocuspic extends Module
{
	public $adv_link_1;
	public $adv_link_2;
	public $adv_link_3;
	
	public $adv_img_1;
	public $adv_img_2;
	public $adv_img_3;

	public $adv_imgname_1 = 'advertising_1';
	public $adv_imgname_2 = 'advertising_2';
	public $adv_imgname_3 = 'advertising_3';

	function __construct()
	{
		$this->name = 'uhufocuspic';
		$this->tab = 'advertising_marketing';
		$this->version = 0.1;
		
		parent::__construct();
		
		$this->displayName = $this->l('Block Focus images by uhupage');
		$this->description = $this->l('Adds a block to display all focus pictures');

		$current_dir = defined('__DIR__')?__DIR__:dirname(__FILE__);
		if (!file_exists($current_dir.'/'.$this->adv_imgname_1.'.'.Configuration::get('UHUFOCUS_IMG_EXT')))
			$this->adv_img_1 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/advertising_1.jpg';
		else
			$this->adv_img_1 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname_1.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
		$this->adv_link_1 = htmlentities(Configuration::get('UHUFOCUS_LINK_1'), ENT_QUOTES, 'UTF-8');
	
		if (!file_exists($current_dir.'/'.$this->adv_imgname_2.'.'.Configuration::get('UHUFOCUS_IMG_EXT')))
			$this->adv_img_2 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/advertising_2.jpg';
		else
			$this->adv_img_2 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname_2.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
		$this->adv_link_2 = htmlentities(Configuration::get('UHUFOCUS_LINK_2'), ENT_QUOTES, 'UTF-8');

		if (!file_exists($current_dir.'/'.$this->adv_imgname_3.'.'.Configuration::get('UHUFOCUS_IMG_EXT')))
			$this->adv_img_3 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/advertising_3.jpg';
		else
			$this->adv_img_3 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname_3.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
		$this->adv_link_3 = htmlentities(Configuration::get('UHUFOCUS_LINK_3'), ENT_QUOTES, 'UTF-8');
		
	}
	
	function install()
	{
		Configuration::updateValue('UHUFOCUS_IMG_EXT', 'jpg');
		Configuration::updateValue('UHUFOCUS_LINK_1', "category.php?id_category=2");
		Configuration::updateValue('UHUFOCUS_LINK_2', "category.php?id_category=3");
		Configuration::updateValue('UHUFOCUS_LINK_3', "category.php?id_category=4");
		
		if (!parent::install())
			return false;
		if (!$this->registerHook('top') OR !$this->registerHook('header'))
			return false;
		    return true;
	}
	
	/**
	 * _deleteCurrentImg delete current image, (so this will use default image)
	 * 
	 * @return void
	 */
	private function _deleteCurrentImg1()
	{
		// can work before 5.3
		$current_dir=defined(__DIR__)?__DIR__:dirname(__FILE__);

		if(file_exists($current_dir.'/'.$this->adv_imgname_1.'.'.Configuration::get('UHUFOCUS_IMG_EXT')))
			unlink($current_dir.'/'.$this->adv_imgname_1.'.'.Configuration::get('UHUFOCUS_IMG_EXT'));
	}
	private function _deleteCurrentImg2()
	{
		// can work before 5.3
		$current_dir=defined(__DIR__)?__DIR__:dirname(__FILE__);

		if(file_exists($current_dir.'/'.$this->adv_imgname_2.'.'.Configuration::get('UHUFOCUS_IMG_EXT')))
			unlink($current_dir.'/'.$this->adv_imgname_2.'.'.Configuration::get('UHUFOCUS_IMG_EXT'));
	}
	private function _deleteCurrentImg3()
	{
		// can work before 5.3
		$current_dir=defined(__DIR__)?__DIR__:dirname(__FILE__);

		if(file_exists($current_dir.'/'.$this->adv_imgname_3.'.'.Configuration::get('UHUFOCUS_IMG_EXT')))
			unlink($current_dir.'/'.$this->adv_imgname_3.'.'.Configuration::get('UHUFOCUS_IMG_EXT'));
	}

	public function postProcess()
	{
		global $currentIndex;

		$errors = '';
		if (Tools::isSubmit('submitDeleteImgConf1'))
			$this->_deleteCurrentImg1();	

		if (Tools::isSubmit('submitAdvConf1'))
		{
			$file = false;
			if (isset($_FILES['adv_img_1']) AND isset($_FILES['adv_img_1']['tmp_name']) AND !empty($_FILES['adv_img_1']['tmp_name']))
			{
				if ($error = checkImage($_FILES['adv_img_1'], 4000000))
					$errors .= $error;
				elseif ($dot_pos = strrpos($_FILES['adv_img_1']['name'],'.'))
				{
					// __DIR__ exists since php 5.3
					$current_dir = defined(__DIR__)?__DIR__:dirname(__FILE__);
					// as checkImage tell us it's a good image, we'll just copy the extension
					$ext=substr($_FILES['adv_img_1']['name'], $dot_pos+1);
					$newname=$this->adv_imgname_1.'.'.$ext;

					$this->_deleteCurrentImg1();

					if (!move_uploaded_file($_FILES['adv_img_1']['tmp_name'], $current_dir.'/'.$newname))
						$errors .= $this->l('Error move uploaded file');

					Configuration::updateValue('UHUFOCUS_IMG_EXT',$ext);
					$this->adv_img_1 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname_1.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
				}
			}

			if ($link = Tools::getValue('adv_link_1'))
			{
				Configuration::updateValue('UHUFOCUS_LINK_1', $link);
				$this->adv_link_1 = htmlentities($link, ENT_QUOTES, 'UTF-8');
			}
		}
		
		if (Tools::isSubmit('submitDeleteImgConf2'))
			$this->_deleteCurrentImg2();	

		if (Tools::isSubmit('submitAdvConf2'))
		{
			$file = false;
			if (isset($_FILES['adv_img_2']) AND isset($_FILES['adv_img_2']['tmp_name']) AND !empty($_FILES['adv_img_2']['tmp_name']))
			{
				if ($error = checkImage($_FILES['adv_img_2'], 4000000))
					$errors .= $error;
				elseif ($dot_pos = strrpos($_FILES['adv_img_2']['name'],'.'))
				{
					// __DIR__ exists since php 5.3
					$current_dir = defined(__DIR__)?__DIR__:dirname(__FILE__);
					// as checkImage tell us it's a good image, we'll just copy the extension
					$ext=substr($_FILES['adv_img_2']['name'], $dot_pos+1);
					$newname=$this->adv_imgname_2.'.'.$ext;

					$this->_deleteCurrentImg2();

					if (!move_uploaded_file($_FILES['adv_img_2']['tmp_name'], $current_dir.'/'.$newname))
						$errors .= $this->l('Error move uploaded file');

					Configuration::updateValue('UHUFOCUS_IMG_EXT',$ext);
					$this->adv_img_1 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname_2.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
				}
			}

			if ($link = Tools::getValue('adv_link_2'))
			{
				Configuration::updateValue('UHUFOCUS_LINK_2', $link);
				$this->adv_link_2 = htmlentities($link, ENT_QUOTES, 'UTF-8');
			}
		}
		
		if (Tools::isSubmit('submitDeleteImgConf3'))
			$this->_deleteCurrentImg3();	

		if (Tools::isSubmit('submitAdvConf3'))
		{
			$file = false;
			if (isset($_FILES['adv_img_3']) AND isset($_FILES['adv_img_3']['tmp_name']) AND !empty($_FILES['adv_img_3']['tmp_name']))
			{
				if ($error = checkImage($_FILES['adv_img_3'], 4000000))
					$errors .= $error;
				elseif ($dot_pos = strrpos($_FILES['adv_img_3']['name'],'.'))
				{
					// __DIR__ exists since php 5.3
					$current_dir = defined(__DIR__)?__DIR__:dirname(__FILE__);
					// as checkImage tell us it's a good image, we'll just copy the extension
					$ext=substr($_FILES['adv_img_3']['name'], $dot_pos+1);
					$newname=$this->adv_imgname_3.'.'.$ext;

					$this->_deleteCurrentImg3();

					if (!move_uploaded_file($_FILES['adv_img_3']['tmp_name'], $current_dir.'/'.$newname))
						$errors .= $this->l('Error move uploaded file');

					Configuration::updateValue('UHUFOCUS_IMG_EXT',$ext);
					$this->adv_img_3 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname_3.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
				}
			}

			if ($link = Tools::getValue('adv_link_3'))
			{
				Configuration::updateValue('UHUFOCUS_LINK_3', $link);
				$this->adv_link_3 = htmlentities($link, ENT_QUOTES, 'UTF-8');
			}
		}
		
		if (Tools::isSubmit('submitDeleteImgConf'))
			$this->_deleteCurrentImg();	

		if (Tools::isSubmit('submitAdvConf'))
		{
			$file = false;
			if (isset($_FILES['adv_img']) AND isset($_FILES['adv_img']['tmp_name']) AND !empty($_FILES['adv_img']['tmp_name']))
			{
				if ($error = checkImage($_FILES['adv_img'], 4000000))
					$errors .= $error;
				elseif ($dot_pos = strrpos($_FILES['adv_img']['name'],'.'))
				{
					// __DIR__ exists since php 5.3
					$current_dir = defined(__DIR__)?__DIR__:dirname(__FILE__);
					// as checkImage tell us it's a good image, we'll just copy the extension
					$ext=substr($_FILES['adv_img']['name'], $dot_pos+1);
					$newname=$this->adv_imgname.'.'.$ext;

					$this->_deleteCurrentImg();

					if (!move_uploaded_file($_FILES['adv_img']['tmp_name'], $current_dir.'/'.$newname))
						$errors .= $this->l('Error move uploaded file');

					Configuration::updateValue('UHUFOCUS_IMG_EXT',$ext);
					$this->adv_img = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname.'.'.Configuration::get('UHUFOCUS_IMG_EXT');
				}
			}

			if ($link = Tools::getValue('adv_link'))
			{
				Configuration::updateValue('UHUFOCUS_LINK', $link);
				$this->adv_link = htmlentities($link, ENT_QUOTES, 'UTF-8');
			}
		}
		
		if ($errors)
			echo $this->displayError($errors);
	}

	/**
	 * getContent used to display admin module form
	 * 
	 * @return void
	 */
	public function getContent()
	{
		global $protocol_content;
		
		$this->postProcess();
		$output = '';
		$output .= '
<form style="float:left; width:100%; margin-bottom: 20px;" action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data">
<fieldset><legend>'.$this->l('Advertising 1 configuration').'</legend>
<a href="'.$this->adv_link_1.'" target="_blank" title="'.$this->l('Advertising').'">';
		if ($this->adv_img_1)
			$output .= '<img src="'.$protocol_content.$this->adv_img_1.'" alt="'.$this->l('Advertising image').'" style="height:396px; width:866px"/>';
		else
			$output .= $this->l('no image');
		$output .= '</a>';
		if ($this->adv_img_1)
			$output .= '<input class="button" type="submit" name="submitDeleteImgConf1" value="'.$this->l('delete image').'" style=""/>';
		$output .= '<br/>
		<br/>
( '.$this->l('image must be set as 866x396').' )
<br/>
<label style="width: 150px;" for="adv_img_1">'.$this->l('Change image').'&nbsp;&nbsp;</label><input id="adv_img_1" type="file" name="adv_img_1" />
<br/>
<br class="clear"/>
<label style="width: 150px;" for="adv_link_1">'.$this->l('Image link').'&nbsp;&nbsp;</label><input style="width: 230px;" id="adv_link_1" type="text" name="adv_link_1" value="'.$this->adv_link_1.'" />
<br class="clear"/>
<br/>
<input class="button" type="submit" name="submitAdvConf1" value="'.$this->l('validate').'" style="margin-left: 200px;"/>
</fieldset>
</form>
';

		$output .= '
<form style="float:left; width:100%;  margin-bottom: 20px;" action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data">
<fieldset><legend>'.$this->l('Advertising 2 configuration').'</legend>
<a href="'.$this->adv_link_2.'" target="_blank" title="'.$this->l('Advertising').'">';
		if ($this->adv_img_2)
			$output .= '<img src="'.$protocol_content.$this->adv_img_2.'" alt="'.$this->l('Advertising image').'" style="height:396px; width:866px"/>';
		else
			$output .= $this->l('no image');
		$output .= '</a>';
		if ($this->adv_img_2)
			$output .= '<input class="button" type="submit" name="submitDeleteImgConf2" value="'.$this->l('delete image').'" style=""/>';
		$output .= '<br/>
		<br/>
( '.$this->l('image must be set as 866x396').' )
<br/>
<label style="width: 150px;" for="adv_img_2">'.$this->l('Change image').'&nbsp;&nbsp;</label><input id="adv_img_2" type="file" name="adv_img_2" />
<br/>
<br class="clear"/>
<label style="width: 150px;" for="adv_link_2">'.$this->l('Image link').'&nbsp;&nbsp;</label><input style="width: 230px;" id="adv_link_2" type="text" name="adv_link_2" value="'.$this->adv_link_2.'" />
<br class="clear"/>
<br/>
<input class="button" type="submit" name="submitAdvConf2" value="'.$this->l('validate').'" style="margin-left: 200px;"/>
</fieldset>
</form>
';

		$output .= '
<form style="float:left; width:100%;  margin-bottom: 20px;" action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data">
<fieldset><legend>'.$this->l('Advertising 3 configuration').'</legend>
<a href="'.$this->adv_link_3.'" target="_blank" title="'.$this->l('Advertising').'">';
		if ($this->adv_img_3)
			$output .= '<img src="'.$protocol_content.$this->adv_img_3.'" alt="'.$this->l('Advertising image').'" style="height:396px; width:866px"/>';
		else
			$output .= $this->l('no image');
		$output .= '</a>';
		if ($this->adv_img_3)
			$output .= '<input class="button" type="submit" name="submitDeleteImgConf3" value="'.$this->l('delete image').'" style=""/>';
		$output .= '<br/>
		<br/>
( '.$this->l('image must be set as 866x396').' )
<br/>
<label style="width: 150px;" for="adv_img_3">'.$this->l('Change image').'&nbsp;&nbsp;</label><input id="adv_img_3" type="file" name="adv_img_3" />
<br/>
<br class="clear"/>
<label style="width: 150px;" for="adv_link_3">'.$this->l('Image link').'&nbsp;&nbsp;</label><input style="width: 230px;" id="adv_link_3" type="text" name="adv_link_3" value="'.$this->adv_link_3.'" />
<br class="clear"/>
<br/>
<input class="button" type="submit" name="submitAdvConf3" value="'.$this->l('validate').'" style="margin-left: 200px;"/>
</fieldset>
</form>
';


		return $output;
	}
		

	function hookTop($params)
	{
		global $smarty, $protocol_content;

		$smarty->assign('image_1', $protocol_content.$this->adv_img_1);
		$smarty->assign('adv_link_1', $this->adv_link_1);

		$smarty->assign('image_2', $protocol_content.$this->adv_img_2);
		$smarty->assign('adv_link_2', $this->adv_link_2);

		$smarty->assign('image_3', $protocol_content.$this->adv_img_3);
		$smarty->assign('adv_link_3', $this->adv_link_3);
	
		return $this->display(__FILE__, 'uhufocuspic.tpl');
	}

	function hookHeader($params)
	{
		Tools::addCSS(($this->_path).'uhufocuspic.css', 'all');
	}

}
?>